
      '************************************************************************************************
      '*            Automatically generate a manifest file for XP style buttons common controls
      '*      based on code QXpTheme by Nicolas Tillet http://www.membres.lycos.fr/ntillet86
      '*  Modified for RQ2 by JohnK,  11/2005
      '************************************************************************************************
      '*  Modified by V. Dobiasch, added XPgroupbox
      '
      'usage
      ' $XP_MANIFEST(MyFormName, MyFormVersion, Description)
      ' XPButton(MyQbutton)
      '

$IFNDEF __WIN32API        'for windows 32 API calls/constants
    $IFNDEF __RQINC2        ' & rapidQ2
        $IFNDEF __RQINC        ' & rapidQ
            DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG,nIndex AS LONG, dwNewLong AS LONG) AS LONG
        $ENDIF        
        DECLARE FUNCTION GetWindowLong LIB "USER32" ALIAS "GetWindowLongA"(hwnd AS LONG , TYPE AS LONG) AS LONG
        CONST GWL_STYLE = - 16
        TYPE OSVERSIONINFO
            dwOSVersionInfoSize AS LONG
            dwMajorVersion AS LONG
            dwMinorVersion AS LONG
            dwBuildNumber AS LONG
            dwPlatformId AS LONG
            szCSDVersion AS STRING * 128
        END TYPE
        DECLARE FUNCTION GetVersionEx LIB "kernel32.dll" ALIAS "GetVersionExA"(lpVersionInformation AS OSVERSIONINFO) AS LONG
        DECLARE FUNCTION GetSysColor LIB "user32" ALIAS "GetSysColor"(nIndex AS LONG) AS LONG
    $ENDIF
$ENDIF

DEFBYTE XPpresent = False , ManifestPresent = False

SUB XPButton(btn AS QBUTTON)
    IF XPpresent = True THEN
        SetWindowLong(btn.Handle , GWL_STYLE ,(GetWindowLong(btn.Handle , GWL_STYLE) XOR 11) + btn.Default)
    END IF
END SUBI

DECLARE FUNCTION EnumResourceTypes LIB "kernel32" ALIAS "EnumResourceTypesA"(hModule AS LONG , lpEnumFunc AS LONG , lParam AS LONG) AS LONG

FUNCTION lrproc(hwind AS LONG , lpsztype AS LONG , flag AS LONG) AS LONG
    IF lpsztype = 24 THEN
        ManifestPresent = True
        result = False
    ELSE
        result = True
    END IF
END FUNCTION

SUB $XP_MANIFEST(Name AS STRING , Version AS STRING , Description AS STRING)
    DIM gRQ2_manifest AS QFILESTREAM
    DIM OSV AS OSVERSIONINFO
    OSV.dwOSVersionInfoSize = SIZEOF(OSV)
    GetVersionEx(OSV)
    IF (OSV.dwMajorVersion = > 5 AND OSV.dwMinorVersion > 0) THEN
        XPpresent = True
        EnumResourceTypes(0 , CODEPTR(lrproc) , 19095513)
        IF ManifestPresent = False AND FILEEXISTS(Command$(0) + ".manifest") = 0 THEN        'no manifest file, so generate it
            gRQ2_manifest.Open(Command$(0) + ".manifest" , 65535)
            gRQ2_manifest.WriteLine("<?xml version=" + CHR$(34) + "1.0" + CHR$(34) + " encoding=" + CHR$(34) + "UTF-8" + CHR$(34) + " standalone=" + CHR$(34) + "yes" + CHR$(34) + "?>")
            gRQ2_manifest.WriteLine("<assembly xmlns=" + CHR$(34) + "urn:schemas-microsoft-com:asm.v1" + CHR$(34) + " manifestVersion=" + CHR$(34) + "1.0" + CHR$(34) + ">")
            gRQ2_manifest.WriteLine("<assemblyIdentity")
            gRQ2_manifest.WriteLine("    version = " + CHR$(34) + Version + CHR$(34))
            gRQ2_manifest.WriteLine("    processorArchitecture = " + CHR$(34) + "X86" + CHR$(34))
            gRQ2_manifest.WriteLine("    name = " + CHR$(34) + Name + CHR$(34))
            gRQ2_manifest.WriteLine("    type=" + CHR$(34) + "win32" + CHR$(34))
            gRQ2_manifest.WriteLine("    />")
            gRQ2_manifest.WriteLine("<description>" + Description + "</description>")
            gRQ2_manifest.WriteLine("<dependency>")
            gRQ2_manifest.WriteLine("    <dependentAssembly>")
            gRQ2_manifest.WriteLine("        <assemblyIdentity")
            gRQ2_manifest.WriteLine("        type=" + CHR$(34) + "win32" + CHR$(34))
            gRQ2_manifest.WriteLine("        name = " + CHR$(34) + "Microsoft.Windows.Common-Controls" + CHR$(34))
            gRQ2_manifest.WriteLine("        version = " + CHR$(34) + "6.0.0.0" + CHR$(34))
            gRQ2_manifest.WriteLine("        processorArchitecture = " + CHR$(34) + "X86" + CHR$(34))
            gRQ2_manifest.WriteLine("        publicKeyToken = " + CHR$(34) + "6595b64144ccf1df" + CHR$(34))
            gRQ2_manifest.WriteLine("        language = " + CHR$(34) + "*" + CHR$(34))
            gRQ2_manifest.WriteLine("        />")
            gRQ2_manifest.WriteLine("    </dependentAssembly>")
            gRQ2_manifest.WriteLine("</dependency>")
            gRQ2_manifest.WriteLine("</assembly>")
            gRQ2_manifest.Close
        END IF
    END IF
END SUB

DECLARE SUB OnClick_EventTemplate
TYPE XpGroupBox EXTENDS QPANEL
    OnClick AS EVENT(OnClick_EventTemplate)
    Public:
    Caption AS STRING
    CaptionPosition as Long
    Bottomtext AS STRING
    BottomtextPosition as Long
    BorderColor AS LONG
    CaptionColor AS LONG
    Private:
    Canvas AS QCANVAS
    EVENT Canvas.OnPaint
        DEFLNG BtnFace = GetSysColor(15) , Badj = 1 , Yadj = 1 , BC
''        DEFLNG BtnFace = GetSysColor(5) , Badj = 1 , Yadj = 1 , BC
        IF XpGroupBox.caption <> "" THEN Yadj = XpGroupBox.Canvas.TextHeight("Xp") / 2
        IF XpGroupBox.bottomtext <> "" THEN Badj = XpGroupBox.Canvas.TextHeight("Xp") / 2
        IF XPpresent THEN        ' adjust border color to suit btnface
            IF BtnFace = &HE3DFE0 THEN        ' silver theme
                BC = &H5C7777
            ELSE        ' blue or olive theme
                BC = &HBFD0D0
            END IF
            XpGroupBox.Canvas.RoundRect(0, Yadj , XpGroupBox.Width - 1 , XpGroupBox.Height - 1 - Badj ,6,6, BC)
            XpGroupBox.Canvas.RoundRect(1, Yadj + 1 , XpGroupBox.Width - 2 , XpGroupBox.Height -2- Badj ,6,6,Xpgroupbox.color)
        ELSE
            BC = XpGroupBox.BorderColor
            XpGroupBox.Canvas.Rectangle(1, Yadj + 1 , XpGroupBox.Width - 1 , XpGroupBox.Height - Badj , &HFFFFFF)
            XpGroupBox.Canvas.Rectangle(0, Yadj , XpGroupBox.Width - 2 , XpGroupBox.Height - 1 - Badj , BC)
        END IF
        XpGroupBox.Canvas.TextOut(XpGroupBox.CaptionPosition , 0 , XpGroupBox.Caption , XpGroupBox.CaptionColor , BtnFace)
        XpGroupBox.Canvas.TextOut(XpGroupBox.BottomtextPosition , XpGroupBox.Height - 1 - 2 * Yadj , XpGroupBox.Bottomtext , XpGroupBox.CaptionColor , BtnFace)
    END EVENT

    EVENT Canvas.OnClick
        IF XpGroupBox.OnClick <> 0 THEN CALLFUNC XpGroupBox.OnClick
    END EVENT

    CONSTRUCTOR
        CaptionPosition = 7
        Bottomtext = ""
        BottomtextPosition = 7
        BevelWidth = 0
              ''    BorderColor   = &HBFD0D0
        BorderColor = GetSysColor(16)
        CaptionColor = IIF (XPpresent = True , &HD54600 , GetSysColor(18))
        Canvas.Parent = XpGroupBox
        Canvas.Align = 5        'alClient
    END CONSTRUCTOR
END TYPE

$DEFINE QGROUPBOX XpGroupBox
