'** scalar date routines    --    public domain by Ray Gardner
'** These will work over the range 1/01/01 thru 14699/12/31

function isleap(year as word) as integer
 result= (year MOD 400) = 0 or ((year MOD 4) = 0 and (year MOD 100) <> 0)
end function

function months2days(month as word) as integer
   result = (month * 3057 - 3007) \ 100
end function

function years2days(yr as word) as integer
   result = yr * 365 + (yr \ 4) - (yr \ 100) + (yr \ 400)
end function

function ymd2scalar(yr as word, mo as word, day as word) as long
  deflng scalar
  scalar = day + months2days(mo)
  if ( mo > 2 ) then                        '/* adjust if past February */
     if isleap(yr) then 
        scalar = scalar - 1
     else 
        scalar = scalar - 2
     end if
  end if        
  result = scalar + years2days(yr-1)
end function

sub scalar2ymd(scalar as long, byref yr as word, byref mo as word, byref day as word) 
   defword n
   ' *  compute inverse of years_to_days()
   ' *  146097 == years_to_days(400)
   n = (scalar * 400) \ 146097
   while (years2days(n) < scalar)
       inc n
   wend    
   ' *  Years
   yr = n
   n = scalar - years2days(n-1)
   if ( n > 59 ) then             '/* adjust if past February */
      n = n+2
      if isleap(yr) then
         if n>62 then
            n = n-1
         else
            n = n-2
         end if
      end if
   end if        
   mo = (n * 100 + 3007) \ 3057     '/* inverse of months_to_days() */
   day = n - months2days(mo)
end sub

function dow(yr as word, mo as word, day as word) as integer
  ' day of week as a number: 0-6
  result = ymd2scalar(yr, mo, day) MOD 7
end function  
